package ethz.ch.pp.sum;

import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.RecursiveTask;

class SumTask extends RecursiveTask<Integer> {
    int lo, hi;
    int[] arr;

    SumTask(int[] a, int l, int h) {
        lo = l; hi = h; arr = a;
    }

    @Override
    protected Integer compute() {
        int sequentialCutoff = 10_000;
        if (hi - lo <= sequentialCutoff){
            int sum = 0;
            for (int i = lo; i < hi; ++i){
                sum += arr[i];
            }
            return sum;
        } else {
            int mid = lo + (hi - lo) / 2;
            SumTask left = new SumTask(arr, lo, mid);
            SumTask right = new SumTask(arr, mid, hi);
            left.fork();
            right.fork();
            return left.join() + right.join();
        }
    }
}

public class SumWithForkJoin implements Sum {

    @Override
    public int sum(int[] arr, int p) {
        ForkJoinPool fjp = new ForkJoinPool(p);
        return fjp.invoke(new SumTask(arr, 0, arr.length));
    }
}
