package ethz.ch.pp.sum;

import java.util.concurrent.ForkJoinPool;
import java.util.stream.IntStream;

// use the following VM options to get good results (switch off JIT Compilation)
// -Djava.compiler=NONE  -ea
// in this case, Streams is extremely slow. If you reenable JIT Compilation by
// leaving away the option, you'll see that Streams profit a lot from heavy
// optimizations in the VMs for them.
public class SumWithStreams implements Sum {
    @Override
    public int sum(int[] arr, int p) throws Exception {
        ForkJoinPool fjp = new ForkJoinPool(p);
        return fjp.submit(
                () -> IntStream.of(arr)
                        .parallel()
                        .sum()
        ).get();
    }
}
